CREATE TABLE users (
  id int(11) NOT NULL AUTO_INCREMENT,
  username varchar(25) NOT NULL,
  password varchar(56) NOT NULL,
  lastLogin datetime DEFAULT NULL,
  PRIMARY KEY (id)
)
	
CREATE TABLE comments (
  id int(11) NOT NULL AUTO_INCREMENT,
  user_id int(11) NOT NULL,
  comment_text text NOT NULL,
  created timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (id)
);

CREATE TABLE articles (
  id int(11) NOT NULL AUTO_INCREMENT,
  user_id int(11) NOT NULL,
  article_text text NOT NULL,
  created timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  title varchar(55) NOT NULL DEFAULT 'none',
  PRIMARY KEY (id)
) 